/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#include <avr/pgmspace.h>
#include <avr/version.h>
#include <avr/eeprom.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#include "hardware/network/enc28j60.h"
#include "system/net/ethernet.h"
#include "system/net/tcp.h"
#include "system/stdout/stdout.h"
#include "system/config/config.h"

#include "config.h"

int cmd_stats( int argc, char ** argv )
{
	unsigned int REVID,_PHSTAT1,_PHSTAT2;

	// buffer mit ausgabe vorbereiten & ausgeben
	printf_P( PSTR("Ethernet: %ld Bytes in %ld Packeten\r\n") , ByteCounter, PacketCounter );

	#ifdef TCP_with_unsortseq
		printf_P( PSTR("TCP-TX Errors: %d TCP-RX Errors: %d (unsorted %d, oldseq %d)\r\n\r\n"), TXErrorCounter , RXErrorCounter, RXErrorUnsort, RXErrorOldSeq );
	#else
		printf_P( PSTR("TCP-TX Errors: %d TCP-RX Errors: %d (oldseq %d)\r\n\r\n"), TXErrorCounter , RXErrorCounter, RXErrorOldSeq );
	#endif
						
	LockEthernet();
		
	REVID = enc28j60Read( EREVID );
	_PHSTAT1 = enc28j60PhyRead( PHSTAT1 );
	_PHSTAT2 = enc28j60PhyRead( PHSTAT2 );
					
	FreeEthernet();
					
	printf_P( PSTR("ENC28J60:\r\n"));
	printf_P( PSTR("Reg.    | Wert\r\n"));
	printf_P( PSTR("--------+--------\r\n"));
	printf_P( PSTR("Rev.ID  |   0x%02X\r\n") , REVID );
	printf_P( PSTR("PHSTAT1 | 0x%04X\r\n") , _PHSTAT1 );
	printf_P( PSTR("PHSTAT2 | 0x%04X\r\n") , _PHSTAT2 );

}
