/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#ifndef _CONFIG_H
	#define CONFIG_H

	// aktiviert 1-Wire
	#define ONEWIRE
	// aktiviert ADC
	#define ADC_
	// aktiviert GPIO
	#define GPIO

	// aktiviert TCP
	#define TCP
	#ifdef TCP
		// Erlaubt den Stack ein Packet zwischen zu speichern wenn sie in der Falschen reihenfolge kommen
		#define TCP_with_unsortseq
		// Beschleunigt TCP in Verbindung mit Windows
		#define TCP_delayed_ack
	#endif

	// aktiviert UDP
	#define UDP
	
	#ifdef UDP
		// aktiviert DHCP, dazu muss UDP aktiv sein
		// Wenn DHCP nicht benutzt wird kann die statische IP in
		// system/net/ip.c geändert werden
		#define DHCP
		// Versucht bei einem Fehlversuche von DHCP die IP aus der Config zu lesen, sonst die in ip.c
		#define READ_CONFIG
		// aktiviert DNS, dazu muss UDP aktiv sein
		#define DNS
	#endif

	#ifdef TCP
		// aktiviert NTP, dazu muss TCP aktiv sein
		#define NTP

		// aktiviert den Telnet-Server, dazu muss TCP aktiv sein
		#define TELNETSERVER

		// aktiviert den HTTP-Server, dazu muss TCP aktiv sein
		#define HTTPSERVER
		#ifdef HTTPSERVER
			// aktiviert die Stats per Webinterface
			#define HTTPSERVER_STATS
			// aktiviert die Konfiguration per Webinterface
			#define HTTPSERVER_NETCONFIG
			// aktiviert das System-Menü per Webinterface
			#define HTTPSERVER_SYSTEM
			// aktiviert IO auf dem Webinterface
			#define HTTPSERVER_IO
			#ifdef HTTPSERVER_IO
				#ifdef ADC_
					// aktiviert 1-Wire auf dem Webinterface
					#define HTTPSERVER_ADC
				#endif
				#ifdef GPIO
					// aktiviert 1-Wire auf dem Webinterface
					#define HTTPSERVER_GPIO
				#endif
				#ifdef ONEWIRE
					// aktiviert 1-Wire auf dem Webinterface
					#define HTTPSERVER_ONEWIRE
				#endif
			#endif
		#endif
	#endif

#endif /* CONFIG_H */

