/***************************************************************************
 *            tsop17xx.c
 *
 *  Sat May  9 19:48:51 2009
 *  Copyright  2009  Dirk Broßwick
 *  <sharandac@snafu.de>
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#include <avr/io.h>
#include "hardware/pcint/pcint0.h"
#include "hardware/gpio/gpio_out.h"
#include "hardware/timer1/timer1.h"

#include "hardware/tsop17xx/tsop17xx.h"

static unsigned int RC5_code = 0 ;

void RC5_decode( void )
{
	static char RC5_bitstate = 0;
	static unsigned int Code = 0;
	static unsigned int time=0;
	static unsigned int bittime;
	static unsigned int bittime_max;
	static char lastbit;

	if ( timer1_getcounter() < time )
		bittime = ( timer1_gettimerbase() - time ) + timer1_getcounter();
	else
		bittime = ( timer1_getcounter() - time );
	time = timer1_getcounter();


	if ( RC5_bitstate == 0 )
	{
		RC5_bitstate++;
		Code = 1;
		lastbit = 1;
	}
	
	if ( RC5_bitstate == 1 )
	{
		RC5_bitstate++;
		bittime_max = bittime + ( bittime / 5 );
		Code <<= 1;
	}
	
	if ( ( RC5_bitstate > 1 ) && ( RC5_bitstate < 28 ) )
	{
		RC5_bitstate++;

		if ( bittime > bittime_max )
		{
			RC5_bitstate++;
			if ( lastbit == 1 )
				lastbit = 0;
			else
				lastbit = 1;
		}
		
		if ( ( RC5_bitstate & 1 ) == 1 )
		{
			Code |= lastbit;
			Code <<= 1;
		}
		
		if ( RC5_bitstate >= 28 )
		{
			RC5_code = Code;
		}
	}

	if ( RC5_bitstate >= 28 )
		RC5_bitstate = 0;
			
	if ( GPIO_out_state( 1 ) != 1 )
		GPIO_out_set( 1 );
	else
		GPIO_out_clear( 1 );
		
}
 

void TSOP17xx_init( void )
{
	PCINT0_init();
	PCINT0_enablePin( 6 );
	PCINT0_SetCallback( RC5_decode );
	PCINT0_enableinterrupt();
}

unsigned int TSOP17xx_getCode( void )
{
	return( RC5_code );
}